*  FILE: ADVENT02/ASM

*******************************
*
* INVENTORY VERB PROCESSOR
*
*******************************

VINVE EQU *
 LDX #GSCRN
 STX SCRTOP
 LDX #MSG5 I AM CARRYING MSG
 JSR DISPLY
 LDX #OBJECT OBJ CARRYING TBL
 LDD #MAXOBJ SEE IF CARRYING
A@ TST ,X+ .. ANYTHING
 BEQ B@
 INCA
B@ DECB
 BNE A@
 TSTA CARRYING ANYTHING?
 BEQ I@ NO
 LDY #OBJECT
 LDB #MAXOBJ
C@ LDA ,Y+ DISPLAY OBJECTS
 BEQ G@
 LDX #OBJTAB
D@ CMPA ,X+
 BEQ F@
E@ TST ,X+
 BNE E@
 BRA D@
F@ LDA #13
 JSR CHROUT
 JSR DISPLY
 LDX #COMMA
 JSR DISPLY
G@ DECB
 BNE C@
 JSR PERIOD
H@ JMP REPLY
I@ LDX #MSG6 CARRYING NOTHING
 JSR DISPLY
 BRA H@

*******************************
*
* SPECIAL PROC: BLOW HORN
*
*******************************

BLOW01 EQU *
 LDA #26 HORN
 JSR HAVOBJ
 LBEQ DMSG10 DON'T HAVE
 LDX #MSG58
 JSR DISPLY
 LDA ROPESW
 LBNE REPLY
 INC ROPESW
 LDA #34 ROPE
 JSR PUTOBJ
 JMP DMSG11 FOUND SOMETHING

*******************************
*
* PUT VERB PROCESSOR
*
*******************************

VPUT EQU *
 LDA NOUNNO GOOD OBJ NUMBER?
 LBEQ BADINP NO
 CMPA #128 IS IT "PUT ALL"?
 BEQ E@ YES
 JSR HAVOBJ
 LBEQ DMSG10
 JSR PUTOBJ
 JSR CKDRAW
 CLRB
 JSR REPOBJ
 DEC OBJCNT
D@ JMP REPLY
E@ LDX #OBJECT HANDLE "PUT ALL"
 LDB #MAXOBJ
F@ LDA ,X+
 BEQ G@
 CMPA #23 WEARING CLOTHES
 BEQ G@
 CLR -1,X
 DEC OBJCNT
 JSR PUTOBJ
 JSR CKDRAW
G@ DECB
 BNE F@
 BRA D@

*******************************
*
* SPECIAL PROC: PUT WALLET
*
*******************************

PUT01 EQU *
 LDA #10 CLOSED WALLET
 JSR HAVOBJ
 LBNE VPUT
 LDA #18 OPEN WALLET
 JSR HAVOBJ
 LBEQ DMSG10 DON'T HAVE IT
 STA NOUNNO
 JMP VPUT

******************************
*
* SPECIAL PROC: PUT CLOTHES
*
******************************

PUT02 EQU *
 LDA #23 WEARING CLOTHES
 JSR HAVOBJ
 LBEQ VPUT NO
 JMP DMSG30 TOO MODEST

*******************************
*
* SPECIAL PROC: PUT MONEY
*
*******************************

PUT03 EQU *
 LDA #14 $102.00
 JSR HAVOBJ
 LBNE VPUT
 LDA #15 $2.00
 STA NOUNNO
 JMP VPUT

*******************************
*
* SPECIAL PROC: PUT SHAMROCK
*
*******************************

PUT04 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ DMSG10
 LDB ROOM
 CMPB #38
 LBNE VPUT
 LDA #101 SNAKES
 JSR CKOBJ
 LBEQ VPUT
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 LDA NOUNNO
 JSR REPOBJ
 DEC OBJCNT
 JMP DMSG46

*******************************
*
* SPECIAL PROC: PUT FLASHLIGHT
*
*******************************

PUT05 EQU *
 LDA #11 FLASHLIGHT
 JSR CKOBJ
 BNE A@
 LDA #11 FLASHLIGHT
 JSR HAVOBJ
 BNE A@
 LDA #28 LIT FLASHLIGHT
 STA NOUNNO
A@ JMP VPUT

*******************************
*
* SPECIAL PROC: PUT BEER
*
*******************************

PUT06 EQU *
 LDA #32 EMPTY GLASS
 JSR HAVOBJ
 BNE A@
 LDA #32
 JSR CKOBJ
 BNE A@
 LDA #19 BEER
 STA NOUNNO
A@ JMP VPUT

*******************************
*
* PUT OBJECT IN CURRENT ROOM
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: NONE
*
*******************************

VEC17 EQU *
 PSHS D,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
A@ TST ,X+
 BNE A@
 STA -1,X
 PULS D,X,PC

*******************************
*
* MAKE ROOM VISIBLE
*
* INPUT:  A = INVISIBLE ROOM #
*
*******************************

VEC18 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB
 TFR D,X
 PULS A
 LDB #6
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B,X,PC
B@ ANDA #$7F
 STA -1,X
 PULS B,X,PC

* CHECK IF SCREEN NEEDS TO BE
* RE-DRAWN

VEC19 EQU *
 PSHS D,X
 LDX #MOVOBJ
A@ TST ,X
 BEQ D@
 CMPA ,X
 BEQ C@
B@ LEAX 3,X
 BRA A@
C@ LDB 1,X
 CMPB ROOM
 BNE B@
 LDD ROWCOL
 PSHS D
 JSR DRAWSC
 PULS D
 CMPD #$0B00
 BLO D@
 STD ROWCOL
D@ PULS D,X,PC

* RE-DRAW GRAPHIC SCREEN

VEC20 EQU *
 PSHS D,X,Y,U
 LDD #GSCRN
 STD ROWCOL
 LDB ROOM
 DECB
 LDA #6
 MUL
 ADDD #SCRIND
 TFR D,X
 LDA ,X+
 BEQ A@
 DECA
 LSLA
 TFR X,Y
 LDX #SCRTAB
 LDU A,X
 JSR SHOSC2
 TFR Y,X
 JSR SHOOBJ
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
A@ PULS D,X,Y,U,PC

******************************
*
* GET VERB PROCESSOR
*
*******************************

VGET EQU *
 LDA NOUNNO VALID NOUN?
 LBEQ BADINP NO
 CMPA #128 IS IT "GET ALL"?
 BEQ I@ YES
 CMPA #64 IMMOVABLE OBJ?
 LBHI DMSG34 YES
 JSR HAVOBJ
 LBNE DMSG8 ALREADY HAS IT
 LDA OBJCNT CAN HE CARRY MORE?
 CMPA #MAXOBJ
 BHS E@ NO
 LDA NOUNNO SEE IF IN ROOM
 JSR GETOBJ
 BNE F@ FOUND OBJ
 JMP DMSG7
E@ JMP DMSG9
VGET01 EQU *
F@ JSR GIVOBJ
 JSR CKDRAW
 INC OBJCNT
H@ JMP REPLY
I@ LDB ROOM HANDLE "GET ALL"
 DECB
 LDA #RMSIZE
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
J@ TST ,X+
 BMI L@ UNSEEN OBJ
 BEQ L@ NO OBJ
 LDA OBJCNT
 CMPA #MAXOBJ
 BHS E@ CAN'T CARRY MORE
 LDA -1,X
 CMPA #64 IS IT PERM OBJ?
 BHI L@ YES
 CLR -1,X
 LDY #OBJECT
K@ TST ,Y+
 BNE K@
 STA -1,Y
 JSR CKDRAW
 INC OBJCNT
L@ DECB
 BNE J@
 BRA H@

*******************************
*
* SPECIAL PROC: GET WALLET
*
*******************************

GET01 EQU *
 LDA #10 CLOSED WALLET
 JSR CKOBJ
 LBNE VGET
 LDA #10 CLOSED WALLET
 JSR HAVOBJ
 LBNE VGET
 LDA #18 OPEN WALLET
 STA NOUNNO
 JMP VGET

*******************************
*
* SPECIAL PROC: GET MONEY
*
*******************************

GET02 EQU *
 LDA #14 $102.00
 JSR CKOBJ
 BNE A@
 LDA #14 $102.00
 JSR HAVOBJ
 BNE A@
 LDA #15 $2.00
 STA NOUNNO
A@ JMP VGET

*******************************
*
* SPECIAL PROC: GET FLASHLIGHT
*
*******************************

GET03 EQU *
 LDA #11
 JSR CKOBJ
 BNE A@
 LDA #11
 JSR HAVOBJ
 BNE A@
 LDA #28
 STA NOUNNO
A@ JMP VGET

*******************************
*
* SPECIAL PROC: GET BEER
*
*******************************

GET04 EQU *
 LDA #32 EMPTY GLASS
 JSR HAVOBJ
 BNE A@
 LDA #32
 JSR CKOBJ
 BNE A@
 LDA #19 BEER
 STA NOUNNO
A@ JMP VGET

*******************************
*
* RUB VERB PROCESSOR
*
*******************************

VRUB EQU *
 LDA NOUNNO
 CMPA #17 TOKEN
 LBNE BADINP
 JSR HAVOBJ
 LBEQ DMSG10 DON'T HAVE
 LDA ROOM
 CMPA #17
 LBNE REPLY
 LDX #MSG41
 JSR DELAY
 LDA #16
 JMP EXITRM

*******************************
*
* ROLL VERB PROCESSOR
*
*******************************

VROLL EQU *
 LDA NOUNNO
 CMPA #104 GIRL
 BEQ A@
 CMPA #27 OVER
 LBNE BADINP
 LDA #104 GIRL
A@ JSR CKOBJ
 LBEQ DMSG40
 LDX #MSG45
 JSR DELAY
 LDA #12+INV SHAMROCK
 JSR MAKVIS
 BNE B@
 JMP REPLY
B@ JSR CKDRAW
 JMP DMSG11

*******************************
*
* SCORE VERB PROCESSOR
*
*******************************

VSCORE EQU *
 LDX SCORE
 LEAX -1,X
 STX SCORE
 LDY #MSG43A
 JSR ASCLNO
 LDB #4
A@ LDA #'0
 CMPA ,Y+
 BNE B@
 LDA #$20
 STA -1,Y
 DECB
 BNE A@
B@ JMP DMSG43

******************************
*
* SEE IF OBJECT IS IN ROOM AND
* GET IT IF FOUND
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> NOT FOUND
*         A > 0 FOUND & REMOVED
*
*******************************

VEC16 EQU *
 PSHS B,X SAVE REGS
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
 BRA C@
B@ CLR -1,X
C@ TSTA
 PULS B,X,PC

*******************************
*
* CHK IF PLAYER HAS AN OBJECT
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> HE DOESN'T
*           > 0 -> HE HAS IT
*
*******************************

VEC15 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
B@ TSTA
 PULS B,X,PC

*******************************
*
* REPLACE OBJECT PLAYER HAS
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT
* OUTPUT: NONE
*
*******************************

VEC14 EQU *
 PSHS D,X
 PSHS B
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B
 BRA C@
B@ PULS B
 STB -1,X
C@ PULS D,X,PC

*******************************
*
* GIVE PLAYER AN OBJECT
*
* INPUT:  A = OBJECT TO GIVE
* OUTPUT: NONE
*
*******************************

VEC13 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ TST ,X+
 BEQ B@
 DECB
 BNE A@
 BRA C@
B@ STA -1,X
C@ PULS B,X,PC

*******************************
*
* SPECIAL ENTER ROOM ROUTINES
*
*******************************

*      ENTER ROOM 1

ENTR01 EQU *
 PSHS D
 LDA #23 WEARING CLOTHES
 LDB #9 SHIRT & JEANS
 JSR REPOBJ
 PULS D,PC

*      ENTER ROOM 6

ENTR06 EQU *
 PSHS A
 LDA #23 CLOTHES
 JSR HAVOBJ
 BNE A@
 LEAS 3,S
 JMP DMSG31
A@ PULS A,PC

*      ENTER ROOM 8

ENTR08 EQU *
 PSHS A
 LDA #110 MUGGERS
 JSR CKOBJ
 BEQ A@
 LEAS 3,S
 JMP DMSG32 LOOK REALLY MEAN
A@ PULS A,PC

*      ENTER ROOM 17

ENTR17 EQU *
 PSHS A,X
 LDA #17 TOKEN
 JSR HAVOBJ
 BEQ A@
 LDX #MSG42
 JSR DISPLY
A@ PULS A,X,PC

*      ENTER ROOM 44

ENTR44 EQU *
 PSHS A,X
 LDA RANDOM
 ANDA #$7F
 CMPA #30
 BHI A@
 LDX #MSG50 HOLLOW VOICE
 JSR DISPLY
A@ PULS A,X,PC

* ENTER ROOM 46

ENTR46 EQU *
 PSHS A
 LDA #8 SHOES
 JSR HAVOBJ
 BNE B@
 LDX #MSG57 FELL OFF RAINBOW
A@ JSR DISPLY
 JMP ENDGAM
B@ LDA #33 POLE
 JSR HAVOBJ
 BNE C@
 LDX #MSG62
 BRA A@
C@ PULS A,PC

*******************************
*
* SPECIAL IN ROOM ROUTINES
*
*******************************

INRM12 EQU *
 LDA #8 SHOES
 JSR HAVOBJ
 BNE A@
 LDX #MSG44
 JSR DELAY
 LDA #11
 STA ROOM
 LEAS 2,S
 CLR NOUNNO
 JMP VLOOK
A@ RTS

INCAVE EQU *
 LDA ROOM
 CMPA #39
 BLO A@
 CMPA #44
 BHI A@
 LDA #28
 JSR CKOBJ
 BNE A@
 LDA #28
 JSR HAVOBJ
 BNE A@
 LDU #SCRBLK
 JSR SHOSCR
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
 LDX #MSG49
 JSR DISPLY
 LEAS 2,S
 JMP REPLY
A@ RTS

*******************************
*
* SPECIAL EXIT ROOM ROUTINES
*
*******************************

*      EXIT ROOM 1

EXIT01 EQU *
 PSHS D
 LDA #9 SHIRT & JEANS
 LDB #23 WEARING CLOTHES
 JSR REPOBJ
 PULS D,PC

*      EXIT ROOM 4

EXIT04 EQU *
 PSHS A
 LDA NOUNNO
 CMPA #2 GOING SOUTH?
 BEQ A@ YES
 LDA #121 LANDLORD
 JSR CKOBJ
 BEQ A@
 LEAS 3,S
 JMP DMSG22 WON'T LET ME
A@ PULS A,PC

*      EXIT ROOM 6

EXIT06 EQU *
 PSHS A
 LDA NOUNNO
 CMPA #2 GOING SOUTH?
 BEQ A@ YES
 LDA #23 CLOTHES
 JSR HAVOBJ
 BNE A@
 LEAS 3,S
 LDA #15 SET JAIL ROOM
 STA ROOM
 CLR NOUNNO
 JMP VLOOK
A@ PULS A,PC

*      EXIT ROOM 8

EXIT08 EQU *
 PSHS D
 LDA #110 MUGGERS
 JSR CKOBJ
 BEQ B@
 LDA NOUNNO
 CMPA #3 EAST?
 BNE B@ NO
 LDA #15 $2.00
 JSR HAVOBJ
 BEQ A@ NO
 CLRB
 JSR REPOBJ
 DEC OBJCNT
 LDB #2
 STB ROOM
 JSR PUTOBJ
 LDB #8
 STB ROOM
A@ LEAS 4,S
 JMP DMSG33
B@ PULS D,PC

* EXIT ROOM 12

EXIT12 EQU *
 PSHS D
 LDA #19 BEER
 JSR HAVOBJ
 BNE A@
 LDA #32 EMPTY GLASS
 JSR HAVOBJ
 BEQ B@
A@ CLRB
 JSR REPOBJ
 DEC OBJCNT
 JSR PUTOBJ
B@ PULS D,PC

*      EXIT ROOMS 27 & 28

EXIT27 EQU *
 PSHS A
 LDA NOUNNO
 CMPA #6 DOWN
 BNE A@
EXT27A LDA #34 ROPE
 JSR HAVOBJ
 BNE A@
 LDX #MSG61
 JSR DISPLY
 LEAS 3,S
 JMP REPLY
A@ PULS A,PC

*      EXIT ROOM 30

EXIT30 EQU *
 PSHS A
 LDA NOUNNO
 CMPA #5 UP
 BEQ EXT27A
 CMPA #6 DOWN
 BEQ EXT27A
 PULS A,PC

*      EXIT ROOM 38

EXIT38 EQU *
 PSHS A,X
 CMPB #39
 BNE A@
 LDA #33 POLE
 JSR HAVOBJ
 BNE B@
A@ PULS A,X
 BRA EXIT30
B@ LDX #MSG60
 JSR DISPLY
 LEAS 5,S
 JMP REPLY

EXITCV EQU *
 PSHS A
 LDA #28 LIT FLASH
 JSR HAVOBJ
 BNE A@
 LDA #28
 JSR CKOBJ
 BNE A@
 LDA RANDOM
 ANDA #$7F
 CMPA #60
 BHI A@
 LDX #MSG48
 JSR DISPLY
 JMP ENDGAM
A@ PULS A,PC

*******************************
*
* I JUST DON'T UNDERSTAND RTN
*
*******************************

VEC06 EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #MSG4 DON'T UNDERSTAND
 JSR DISPLY
 LDX #KEYBUF
 JSR DISPLY
 LDA #'"
 JSR CHROUT
 BRA VEC07A

*******************************
*
* ADVENTURE MAINLINE ROUTINE
* GET KEYBOARD INPUT, EXAMINE
* AND EXECUTE IT.
*
*******************************

VEC07 EQU *
 LDA ROOM
 CMPA #47
 LBEQ ENDGAM
 TST NEWRM
 BEQ D@
 LDX #ENTRTB
 CLR NEWRM
 BRA E@
D@ LDX #INRMTB
E@ LDA ,X+
 BEQ VEC07A
 CMPA ROOM
 BEQ F@
 LEAX 2,X
 BRA E@
F@ JSR [,X]
VEC07A LDX #MSG0 OK PROMPT
 JSR DISPLY
 JSR GETLIN GET KBD INPUT
 JSR SCNKEY EXAMINE INPUT
 LDD SCORE
 ADDD #1
 STD SCORE
 LDX #SPCRTN SPECIAL ROUTINE
A@ LDD ,X++
 BEQ C@
 CMPD VERBNO
 BNE B@
 JMP [,X]
B@ LEAX 2,X
 BRA A@
C@ LDB VERBNO CURRENT VERB
 LBEQ BADINP VERB NOT FOUND
 DECB
 LSLB
 LDX #RTNTAB VERB ROUTINES
 ABX
 JMP [,X]

*******************************
*
* EXAMINE KEYBOARD INPUT AND
* EXTRACT THE VERB AND NOUN
*
* INPUT:  NONE
* OUTPUT: "VERB" CONTAINS VERB
*         "NOUN" CONTAINS NOUN
*
*******************************

VEC08 EQU *
 PSHS D,X,Y,U SAVE REGS
 LDX #VERB SPACE OUT VERB/NOUN
 TFR X,Y
 LDB #MAXWRD*2-1
 LDA #$20
 STA ,Y+
 JSR MOVE
 TFR X,U
 LDX #KEYBUF KEYBOARD BUFFER
 LDB #MAXWRD MAX VERB SIZE
A@ LDA ,X+ GET THE VERB
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT SPACE?
 BEQ B@ YES:END OF VERB
 STA ,U+ PUT IN "VERB"
 DECB
 BNE A@ LOOP THRU VERB
F@ LDA ,X+ SCAN FOR A SPACE
 BEQ E@
 CMPA #$20
 BNE F@
B@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT A SPACE
 BEQ B@ YES:LOOP TILL NON-BLANK
 DEX BACKUP 1 CHAR
 LDU #NOUN STORAGE FOR NOUN
 LDB #MAXWRD MAX LEN OF NOUN
D@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 SPACE?
 BEQ E@ YES:ALL DONE
 STA ,U+ PUT IN "NOUN"
 DECB
 BNE D@
E@ CLR VERBNO CLEAR VERB/NOUN #
 CLR NOUNNO
 BSR CVTCAP
 LDX #VERBTB GET VERB NUMBER
 LDY #VERBNO
 LDU #VERB
 BSR SCNTBL
 LDX #NOUNTB GET NOUN NUMBER
 LDY #NOUNNO
 LDU #NOUN
 BSR SCNTBL
 PULS D,X,Y,U,PC

*******************************
*
* SCANS TABLE FOR VERB OR NOUN
* RETURNS ASSOCIATED VERB OR
* NOUN NUMBER.
*
* INPUT:  X = PNTR TO TABLE
*         Y = PNTR TO STORAGE
*             FOR VERB/NOUN #
*         U = PNTR TO KEYBOARD
*             INPUT TO SCAN FOR
* OUTPUT: CONTENTS OF "Y" ARE
*         ASSIGNED VERB/NOUN #
*
*******************************

SCNTBL EQU *
 PSHS D,X SAVE REGS
A@ PSHS U
 LDB #MAXWRD LEN OF COMPARE
B@ LDA ,X+ CHAR FROM TABLE
 BEQ C@ IF END OF TABLE
 CMPA ,U+ DO THEY MATCH?
 BNE D@ NO:NEXT TABLE ENTRY
 DECB COMPARE LEN
 BNE B@ LOOP TILL DONE
 LDA ,X GET VERB/NOUN #
 STA ,Y UPDATE USER AREA
C@ PULS U RESTORE "U"
 PULS D,X,PC
D@ INX BUMP TO NEXT ENTRY
 DECB
 BNE D@
 PULS U RESTORE VERB/NOUN
 BRA A@

*******************************
*
* CONVERTS INPUT VERB/NOUN TO
* ALL UPPER CASE LETTERS
*
* INPUT:  NONE
* OUTPUT: "VERB" & "NOUN" ARE
*         CONVERTED TO CAPS
*
*******************************

CVTCAP EQU *
 PSHS D,X SAVE REGS
 LDX #VERB
 LDB #MAXWRD*2
A@ LDA ,X+
 CMPA #'a LESS THAN L/C A?
 BLO B@ YES:SKIP
 CMPA #'z GREATER THEN L/C Z?
 BHI B@ YES:SKIP
 SUBA #32 MAKE UPPER CASE
 STA -1,X PUT IT BACK
B@ DECB
 BNE A@
 PULS D,X,PC

*******************************
*
* BACKUP & ADD PERIOD TO SCREEN
*
*******************************

VEC09 EQU *
 PSHS D,X
A@ JSR CURPOS
 LDB #9
 LDA #$FF
B@ CMPA ,X
 BNE C@
 LEAX 32,X
 DECB
 BNE B@
 LDA #8
 JSR CHROUT
 BRA A@
C@ LDA #'.
 JSR CHROUT
 PULS D,X,PC

*******************************
*
* REPLACE OBJECT IN CURRENT
* ROOM WITH ANOTHER OBJECT
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT OBJ
* OUTPUT: NONE
*
*******************************

VEC10 EQU *
 PSHS X
 PSHS B
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B
 BRA C@
B@ PULS B
 STB -1,X
C@ PULS X,PC

*******************************
*
* TEST IF AN OBJECT IS IN THE
* CURRENT ROOM
*
* INPUT:  A = OBJ TO FIND
* OUTPUT: A = 0 -> NOT FOUND
*
*******************************

VEC11 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
B@ TSTA
 PULS B,X,PC

*******************************
*
* MAKE AND OBJECT VISIBLE IN
* ROOM
*
* INPUT:  A = OBJECT TO FIND
* OUTPUT: NONE
*
*******************************

VEC12 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B,X,PC
B@ ANDA #$7F
 STA -1,X
 PULS B,X,PC

*******************************
*
* HELP VERB PROCESSOR
*
*******************************

VHELP EQU *
 LDB ROOM
 LDX #HELPTB
A@ DECB
 BEQ C@
B@ TST ,X+
 BNE B@
 BRA A@
C@ LDA ,X+
 CMPA #1
 BEQ D@
 CMPA #$FF
 BNE E@
 TST ,X
 BEQ E@
 DEC -1,X
D@ JSR DISPLY
 JMP REPLY
E@ LDX #GENHLP
 LDA RANDOM
 ANDA #3
 BEQ G@
F@ TST ,X+
 BNE F@
 DECA
 BNE F@
G@ JSR DISPLY
 JMP REPLY

*******************************
*
* DISPLAY MESSAGE ROUTINES
*
*******************************

DMSG7 LDA #7
 FCB $8C
DMSG8 LDA #8
 FCB $8C
DMSG9 LDA #9
 FCB $8C
DMSG10 LDA #10
 FCB $8C
DMSG11 LDA #11
 FCB $8C
DMSG12 LDA #12
 FCB $8C
DMSG13 LDA #13
 FCB $8C
DMSG15 LDA #15
 FCB $8C
DMSG16 LDA #16
 FCB $8C
DMSG17 LDA #17
 FCB $8C
DMSG18 LDA #18
 FCB $8C
DMSG19 LDA #19
 FCB $8C
DMSG20 LDA #20
 FCB $8C
DMSG21 LDA #21
 FCB $8C
DMSG22 LDA #22
 FCB $8C
DMSG23 LDA #23
 FCB $8C
DMSG24 LDA #24
 FCB $8C
DMSG25 LDA #25
 FCB $8C
DMSG26 LDA #26
 FCB $8C
DMSG27 LDA #27
 FCB $8C
DMSG29 LDA #29
 FCB $8C
DMSG30 LDA #30
 FCB $8C
DMSG31 LDA #31
 FCB $8C
DMSG32 LDA #32
 FCB $8C
DMSG33 LDA #33
 FCB $8C
DMSG34 LDA #34
 FCB $8C
DMSG35 LDA #35
 FCB $8C
DMSG36 LDA #36
 FCB $8C
DMSG37 LDA #37
 FCB $8C
DMSG38 LDA #38
 FCB $8C
DMSG39 LDA #39
 FCB $8C
DMSG40 LDA #40
 FCB $8C
DMSG43 LDA #43
 FCB $8C
DMSG46 LDA #46
 FCB $8C
DMSG47 LDA #47
 FCB $8C
DMSG54 LDA #54
 FCB $8C
DMSG59 LDA #59
 LDX #MSG1
A@ DECA
 BEQ C@
B@ TST ,X+
 BNE B@
 BRA A@
C@ JSR DISPLY
 JMP REPLY

*      END GAME ROUTINE

ENDGAM EQU *
 LDX SCORE
 LDY #MSG51A
 JSR ASCLNO
 LDB #4
A@ LDA #'0
 CMPA ,Y+
 BNE B@
 LDA #$20
 STA -1,Y
 DECB
 BNE A@
B@ LDX #MSG51
 JSR DISPLY
 CLR $71
C@ BRA C@

*
* END OF FILE: ADVENT02/ASM
*
